#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum NotebookType {
    #[serde(rename = "WORKBOOK")]
    Workbook,
    #[serde(rename = "COMPARISON_WORKBOOK")]
    ComparisonWorkbook,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl NotebookType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            NotebookType::Workbook => "WORKBOOK",
            NotebookType::ComparisonWorkbook => "COMPARISON_WORKBOOK",
            NotebookType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for NotebookType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for NotebookType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for NotebookType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<NotebookType, conjure_object::plain::ParseEnumError> {
        match v {
            "WORKBOOK" => Ok(NotebookType::Workbook),
            "COMPARISON_WORKBOOK" => Ok(NotebookType::ComparisonWorkbook),
            v => v.parse().map(|v| NotebookType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for NotebookType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<NotebookType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the NotebookType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
